#!/usr/bin/env node
import P from "lodash.template";
import c from "lodash.get";
import d from "lodash.lowerfirst";
import f from "chalk";
import { readFileSync as x } from "node:fs";
import { join as t } from "node:path";
import { rootPath as l, configRootPath as C } from "./path.config.mjs";
const N = (r, o, m) => {
  const y = {
    ...o,
    src: r.src,
    srcExample: r.srcExample,
    nameLowerFirst: d(o.name),
    $: "$"
  }, e = m.reduce(
    (i, n) => {
      let a = c(r, n, "");
      if (n.endsWith(".templateFilePath")) {
        const F = t(
          l,
          C,
          a
        );
        a = x(F, "utf-8");
      }
      const h = P(a);
      return i[n] = h(y), console.log(
        f.green(
          `${n}模板解析完成${Array(50 - n.length).fill("").join("_")}`
        )
      ), i;
    },
    {}
  ), s = !!r.type, p = {
    componentDirPath: t(l, e["component.dir"]),
    componentFileContent: e["component.templateFilePath"],
    componentFilePath: t(
      l,
      e["component.dir"],
      e["component.fileName"]
    ),
    componentEntryFileAddContent: e["component.entryTemplate"],
    componentEntryFilePath: t(l, e["component.entryPath"]),
    styleDirPath: t(l, e["style.dir"]),
    styleFileContent: e["style.templateFilePath"],
    styleFilePath: t(l, e["style.dir"], e["style.fileName"]),
    styleVarFileAddContent: e["style.varTemplate"],
    styleVarFilePath: t(l, e["style.varPath"]),
    styleEntryFileAddContent: e["style.entryTemplate"],
    styleEntryFilePath: t(l, e["style.entryPath"]),
    exampleDirPath: t(l, e["example.dir"]),
    exampleFileContent: e["example.templateFilePath"],
    exampleFilePath: t(
      l,
      e["example.dir"],
      e["example.fileName"]
    ),
    exampleEntryFileAddContent: e["example.entryTemplate"],
    exampleEntryFilePath: t(l, e["example.entryPath"])
  };
  return s ? {
    ...p,
    useTypeDir: !0,
    typeDirPath: t(l, e["type.dir"]),
    typeFileContent: e["type.templateFilePath"],
    typeFilePath: t(l, e["type.dir"], e["type.fileName"]),
    typeEntryFileAddContent: e["type.entryTemplate"],
    typeEntryFilePath: t(l, e["type.entryPath"])
  } : {
    ...p,
    useTypeDir: !1
  };
};
export {
  N as resolveTemplate
};
